From 6f76c0a6eb8e9a6c5bd4b81e4b0d16dfee5ab927 Mon Sep 17 00:00:00 2001
From: Jean-Baptiste Holcroft <jean-baptiste@holcroft.fr>
Date: Jun 15 2019 22:32:39 +0000
Subject: [PATCH 1/10] use pandas to clean data


---

diff --git a/build_stats.py b/build_stats.py
new file mode 100755
index 0000000..2a7ddd9
--- /dev/null
+++ b/build_stats.py
@@ -0,0 +1,196 @@
+#!/usr/bin/env python3
+"""Consolidate and clean result files"""
+
+import argparse
+import os
+import pandas
+
+
+def main():
+    """Handle params"""
+
+    parser = argparse.ArgumentParser(
+        description="Consolidate every result files and produce a clean concatenated update")
+    parser.add_argument("--version", required=False, default="f30",
+                        help="Version to analyse (in result folder)")
+
+    args = parser.parse_args()
+
+    file = "./results/"+args.version+"/_concat.csv"
+    parse(file)
+
+
+def parse(concat):
+    """Call all cleaning functions"""
+    data = pandas.read_csv(concat)
+    data.columns = ['src',
+                    'filename',
+                    'translatedMessages',
+                    'translatedSourceWords',
+                    'translatedTargetWords',
+                    'fuzzyMessages',
+                    'fuzzySourceWords',
+                    'untranslatedMessages',
+                    'untranslatedSourceWords',
+                    'totalMessage',
+                    'totalSourceWords',
+                    'reviewMessages',
+                    'reviewSourceWords']
+
+    info(data, "CSV loaded")
+
+    data = clean_0_basic(data)
+
+    data = clean_1_dupplication(data)
+    info(data, "Deduplication is done")
+
+    data = data.astype({
+        'translatedMessages': int,
+        'translatedSourceWords': int,
+        'translatedTargetWords': int,
+        'fuzzyMessages': int,
+        'fuzzySourceWords': int,
+        'untranslatedMessages': int,
+        'untranslatedSourceWords': int,
+        'totalMessage': int,
+        'totalSourceWords': int
+    })
+
+    data = clean_2_remove(data)
+    info(data, "Removal is done")
+
+    data = guess_bcp47(data)
+    info(data, "bcp47 data are guessed")
+
+    data = clean_bcp47(data)
+    info(data, "bcp47 data are cleaned")
+
+    store(data, "3.result.csv")
+
+def clean_0_basic(data):
+    """String cleaning and drops useless 'review' columns"""
+
+    # remove useless spaces and use lowercase
+    for column in list(data):
+        data[column] = data[column].str.strip()
+        data[column] = data[column].str.lower()
+
+    # these columns never have values
+    data = data.drop('reviewMessages', 1)
+    data = data.drop('reviewSourceWords', 1)
+
+    return data
+
+
+def clean_1_dupplication(data):
+    """Removes duplicates"""
+
+    # remove all headers from indivual stat result
+    data = data[data.filename != "filename"]
+    info(data, "* duplicated headers are removed")
+
+    # remove duplicated stats from bad translation file patterns
+    data = data.drop_duplicates(['src', 'filename'], keep='last')
+    info(data, "* duplicated po files are removed")
+
+    return data
+
+
+def clean_2_remove(data):
+    """Removes obvious useless strings"""
+
+    # remove pot files
+    data = data[~(data.filename.str.endswith(".pot"))]
+    info(data, "* remove pot files")
+
+    # remove gmo files
+    data = data[~(data.filename.str.endswith(".gmo"))]
+    info(data, "* remove gmo files")
+
+    # remove when no result
+    store(data[data.totalMessage == 0], "1.debug.total message = 0.csv")
+    data = data[data.totalMessage != 0]
+    info(data, "* remove files with 'totalMessage'=0")
+
+    return data
+
+
+def guess_bcp47(data):
+    """Guess Language, Region and Script from filename"""
+    data['basename'] = data['filename'].apply(os.path.basename)
+
+    data['full_lang'] = data['basename'].str.rsplit('.', 1, expand=True)[0]
+
+    # a few lang naming are wrong
+    data.full_lang = data.full_lang.replace(
+        {'kmr_latn': 'kmr@latn', 'fr-braille': 'fr@braille', })
+
+    data['lang'] = data['full_lang'].str.rsplit('@', 1, expand=True)[0]
+
+    data['script'] = data['full_lang'].str.rsplit('@', 1, expand=True)[1]
+
+    # these are just re-encoded translations
+    data = data[~(
+        data.lang.str.endswith(".big5") |
+        data.lang.str.endswith(".cp936") |
+        data.lang.str.endswith(".cp1250") |
+        data.lang.str.endswith(".cp1251") |
+        data.lang.str.endswith(".euc-jp") |
+        data.lang.str.endswith(".gb2312") |
+        data.lang.str.endswith(".sjis") |
+        data.lang.str.endswith(".utf-8")
+    )]
+    info(data, "* remove if lang endswith encoding values")
+
+    # these are just re-encoded translations
+    store(data[data.lang.str.contains(".", regex=False)], '0.error.lang with point.csv')
+    data = data[~(data.lang.str.contains(".", regex=False))]
+    info(data, "* remove if lang contains a point")
+
+    data['language'] = data['lang'].str.rsplit('_', 1, expand=True)[0]
+
+    data['region'] = data['lang'].str.rsplit('_', 1, expand=True)[1]
+
+    # store all unique values for debug
+    store(data.drop_duplicates('lang', keep='last'), "1.debug.lang.csv")
+    store(data.drop_duplicates('language', keep='last'), "1.debug.language.csv")
+    store(data.drop_duplicates('region', keep='last'), "1.debug.region.csv")
+    store(data.drop_duplicates('script', keep='last'), "1.debug.script.csv")
+
+    # remove temporary columns
+    data = data.drop('full_lang', 1)
+    data = data.drop('lang', 1)
+
+    return data
+
+def clean_bcp47(data):
+    """Remove impossible values for language and region"""
+    # remove region longer than 2 chars
+    store(data[data.region.str.len() > 2], '0.error.len(region)>2.csv')
+    data = data[~(data.region.str.len() > 2)]
+    info(data, "* remove if len(region)>2")
+
+    # remove languages longer than 3 chars
+    store(data[data.language.str.len() > 3], '0.error.len(language)>3.csv')
+    data = data[~(data.language.str.len() > 3)]
+    info(data, "* remove if len(language)>3")
+
+    # remove numeric languages
+    store(data[data.language.str.isdigit()], '0.error.languages is numeric.csv')
+    data = data[~(data.language.str.isdigit())]
+    info(data, "* remove if language.isdigit()")
+
+    return data
+
+def info(dataset, step):
+    """Print basic informations about current dataset"""
+    print(" * "+step+" → we now have "+str(len(dataset))+" rows")
+
+
+def store(dataset, name):
+    """Store dataset to csv"""
+    dataset.to_csv(name, index=False)
+
+
+if __name__ == '__main__':
+    main()
